#include <iostream>
#include "route.h"
using namespace std;

Graph	g;
NodeAttribute<int> id;	
NodeAttribute<int> color ( 0 );	// 0 = no color


int main()
{
	const int numberOfSources = 2;
	const int numberOfTargets = 2;
	const int NumberOfNodes = 6;

	Node nodes[ NumberOfNodes ];
	NodeVector sources( numberOfSources );
	NodeVector targets( numberOfTargets );
	NodePathVector pathes( numberOfTargets );

	int i;

	// construct graph
	for ( i=0; i<NumberOfNodes; i++)
	{
		nodes[i] = g.CreateNode();
		id[ nodes[i] ] = i;
	}

	g.CreateEdge( nodes[1], nodes[2] );
	g.CreateEdge( nodes[0], nodes[1] );
	g.CreateEdge( nodes[4], nodes[5] );
	g.CreateEdge( nodes[3], nodes[4] );

	g.CreateEdge( nodes[1], nodes[5] );
	g.CreateEdge( nodes[4], nodes[2] );
	g.CreateEdge( nodes[0], nodes[4] );
	g.CreateEdge( nodes[3], nodes[1] );


	// set SourceNode nodes

	sources[0] = nodes[0];
	sources[1] = nodes[3];

	color[ sources[0] ] = 200;
	color[ sources[1] ] = 100;

	// set TargetNode nodes

	targets[0] = nodes[2];
	targets[1] = nodes[5];

	color[ targets[0] ] = 100;
	color[ targets[1] ] = 200;

	// prepare pathes

	for (i =0; i<numberOfTargets; i++ )
	{
		pathes[i].AddLast( targets[i] );
	}

	NodeAttribute< bool > multible( true ); 
	NodeAttribute< int > componentNumber( 0 );

	Router router( g, color, multible, componentNumber, id );
	bool ret = router.SearchColoredPathes( pathes );

	if (ret)
		printf( "\nSearch SUCCESS\n");
	else
		printf( "\nSearch FAILURE\n");

//	pathes[0].AddLast( nodes[4] ); //check fails
//	color[ nodes[4] ] = 100;


	ret = router.CheckPathes( sources, targets, pathes );

	if (ret)
		printf( "\nCheck SUCCESS\n");
	else
		printf( "\nCheck FAILURE\n");


	for ( i=0; i<numberOfTargets; i++)
	{
		char strNumber[32];
		sprintf( strNumber, "path %d :", i );
		pathes[i].Print( strNumber, id );
	}

	return 0;
}

